SystemOrganization addCategory: #'Epic-Library'!

Object subclass: #EAuthor
	instanceVariableNames: 'firstName lastName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Epic-Library'!

!EAuthor methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:37'!
firstName
	"Answer the value of firstName"

	^ firstName! !

!EAuthor methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:37'!
firstName: anObject
	"Set the value of firstName"

	firstName := anObject! !

!EAuthor methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:37'!
lastName
	"Answer the value of lastName"

	^ lastName! !

!EAuthor methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:37'!
lastName: anObject
	"Set the value of lastName"

	lastName := anObject! !

Object subclass: #EBook
	instanceVariableNames: 'isbn title authors copies'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Epic-Library'!

!EBook methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:36'!
authors
	"Answer the value of authors"

	^ authors! !

!EBook methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:36'!
authors: anObject
	"Set the value of authors"

	authors := anObject! !

!EBook methodsFor: 'accessing' stamp: 'RS 10/18/2010 20:39'!
copies
	"Answer the value of copies"

	^ copies! !

!EBook methodsFor: 'accessing' stamp: 'RS 10/18/2010 20:39'!
copies: anObject
	"Set the value of copies"

	copies := anObject! !

!EBook methodsFor: 'initialize-release' stamp: 'RS 10/18/2010 20:45'!
initialize
	self 
		authors: OrderedCollection new;
		copies: 1.
	! !

!EBook methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:36'!
isbn
	"Answer the value of isbn"

	^ isbn! !

!EBook methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:36'!
isbn: anObject
	"Set the value of isbn"

	isbn := anObject! !

!EBook methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:36'!
title
	"Answer the value of title"

	^ title! !

!EBook methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:36'!
title: anObject
	"Set the value of title"

	title := anObject! !

Object subclass: #EImageDatabase
	instanceVariableNames: ''
	classVariableNames: 'Books'
	poolDictionaries: ''
	category: 'Epic-Library'!

!EImageDatabase class methodsFor: 'as yet unclassified' stamp: 'RS 10/18/2010 20:20'!
books
	^ Books ifNil: [Books := OrderedCollection new]! !

Object subclass: #EUser
	instanceVariableNames: 'id email password firstName lastName borrowedBooks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Epic-Library'!

!EUser methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:46'!
borrowedBooks
	"Answer the value of borrowedBooks"

	^ borrowedBooks! !

!EUser methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:46'!
borrowedBooks: anObject
	"Set the value of borrowedBooks"

	borrowedBooks := anObject! !

!EUser methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:32'!
email
	"Answer the value of email"

	^ email! !

!EUser methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:32'!
email: anObject
	"Set the value of email"

	email := anObject! !

!EUser methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:32'!
firstName
	"Answer the value of firstName"

	^ firstName! !

!EUser methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:32'!
firstName: anObject
	"Set the value of firstName"

	firstName := anObject! !

!EUser methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:32'!
id
	"Answer the value of id"

	^ id! !

!EUser methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:32'!
id: anObject
	"Set the value of id"

	id := anObject! !

!EUser methodsFor: 'initialize-release' stamp: 'RS 10/18/2010 16:46'!
initialize
	self borrowedBooks: OrderedCollection new.! !

!EUser methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:32'!
lastName
	"Answer the value of lastName"

	^ lastName! !

!EUser methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:32'!
lastName: anObject
	"Set the value of lastName"

	lastName := anObject! !

!EUser methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:32'!
password
	"Answer the value of password"

	^ password! !

!EUser methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:32'!
password: anObject
	"Set the value of password"

	password := anObject! !

WAComponent subclass: #EBookComponent
	instanceVariableNames: 'books menuComponent listComponent bookEditor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Epic-Library'!

!EBookComponent methodsFor: 'accessing' stamp: 'RS 10/18/2010 19:23'!
bookEditor
	"Answer the value of bookEditor"

	^ bookEditor! !

!EBookComponent methodsFor: 'accessing' stamp: 'RS 10/18/2010 19:23'!
bookEditor: anObject
	"Set the value of bookEditor"

	bookEditor := anObject! !

!EBookComponent methodsFor: 'accessing' stamp: 'RS 10/18/2010 18:40'!
books
	"Answer the value of books"

	^ books! !

!EBookComponent methodsFor: 'accessing' stamp: 'RS 10/18/2010 18:40'!
books: anObject
	"Set the value of books"

	books := anObject! !

!EBookComponent methodsFor: 'rendering' stamp: 'sec 10/18/2010 22:44'!
children
	^Array with: self menuComponent with: self listComponent with: self bookEditor.! !

!EBookComponent methodsFor: 'as yet unclassified' stamp: 'sec 10/18/2010 23:03'!
createBook
	(self call: self bookEditor newBook)
		ifNotNil: [self listComponent items add: self bookEditor book]! !

!EBookComponent methodsFor: 'as yet unclassified' stamp: 'RS 10/18/2010 19:52'!
deleteBook: aBook
! !

!EBookComponent methodsFor: 'as yet unclassified' stamp: 'RS 10/18/2010 20:23'!
initialize
	super initialize.
	
	self bookEditor: EBookEditor new.
	self books: EImageDatabase books.
		
	self initializeMenuComponent.
	self initializeListComponent.! !

!EBookComponent methodsFor: 'initialize-release' stamp: 'sec 10/19/2010 00:03'!
initializeListComponent
	self listComponent: (EListComponent new
		columns: #('ISBN' 'Title' 'Number of copies') asArray;
		items: self books;
		sortBlock: [:items | items
				sortBy: [:a :b | a title < b title]];
		
		renderItemBlock: [:book :html | self renderBook: book asRowOn: html];
		filterBlock: [ :books | books ]).! !

!EBookComponent methodsFor: 'initialize-release' stamp: 'RS 10/18/2010 19:46'!
initializeMenuComponent
	self menuComponent: (EMenuComponent new
			addEntry: 'New book' withAction: [self createBook];
			addEntry: 'List books' withAction: [];
			 yourself)! !

!EBookComponent methodsFor: 'accessing' stamp: 'RS 10/18/2010 18:43'!
listComponent
	"Answer the value of listComponent"

	^ listComponent! !

!EBookComponent methodsFor: 'accessing' stamp: 'RS 10/18/2010 18:43'!
listComponent: anObject
	"Set the value of listComponent"

	listComponent := anObject! !

!EBookComponent methodsFor: 'accessing' stamp: 'RS 10/18/2010 19:43'!
menuComponent
	"Answer the value of menuComponent"

	^ menuComponent! !

!EBookComponent methodsFor: 'accessing' stamp: 'RS 10/18/2010 19:43'!
menuComponent: anObject
	"Set the value of menuComponent"

	menuComponent := anObject! !

!EBookComponent methodsFor: 'rendering' stamp: 'sec 10/19/2010 00:01'!
renderBook: aBook asRowOn: html 
	html	tableData: aBook isbn;
			tableData: aBook title;
			tableData: aBook copies;
			tableData: [ html anchor 
				callback: [self call: (self bookEditor editBook: aBook)]; 
				with: '[edit]' ];
			tableData: [ html anchor 
				callback: [self books remove: aBook ifAbsent: []]; 
				with: '[delete]' ].! !

!EBookComponent methodsFor: 'accessing' stamp: 'RS 10/18/2010 19:45'!
renderContentOn: html 
	html heading: 'Books'.
	html div with: self menuComponent.
	html div with: self listComponent! !

!EBookComponent methodsFor: 'as yet unclassified' stamp: 'RS 10/18/2010 18:55'!
testBooks
	^ OrderedCollection 
		with: (EBook new 
			isbn: '3551551677';
			title: 'Harry Potter und der Stein der Weisen')
		with: (EBook new 
			isbn: '3551551685';
			title: 'Harry Potter und die Kammer des Schreckens')! !

WAComponent subclass: #EBookEditor
	instanceVariableNames: 'book mold'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Epic-Library'!

!EBookEditor methodsFor: 'accessing' stamp: 'RS 10/18/2010 19:19'!
book
	"Answer the value of book"

	^ book! !

!EBookEditor methodsFor: 'accessing' stamp: 'sec 10/18/2010 21:27'!
book: anObject
	"Set the value of book"

	book := anObject.
	self buildMold! !

!EBookEditor methodsFor: 'accessing' stamp: 'sec 10/18/2010 22:21'!
buildMold
  self mold: Mold new.
  (self mold stringField)
    label: 'ISBN:';
    on: #isbn of: self book;
    beRequired.
  (self mold stringField)
    label: 'Title:';
    on: #title of: self book;
    beRequired.
  (self mold integerField)
    label: 'Number of copies:';
    on: #copies of: self book;
    beRequired.! !

!EBookEditor methodsFor: 'as yet unclassified' stamp: 'RS 10/18/2010 19:58'!
editBook: aBook
	self book: aBook.! !

!EBookEditor methodsFor: 'accessing' stamp: 'sec 10/18/2010 21:30'!
mold
	"Answer the value of mold"

	^ mold! !

!EBookEditor methodsFor: 'accessing' stamp: 'sec 10/18/2010 21:30'!
mold: anObject
	"Set the value of mold"

	mold := anObject! !

!EBookEditor methodsFor: 'as yet unclassified' stamp: 'RS 10/18/2010 19:23'!
newBook
	self book: EBook new.! !

!EBookEditor methodsFor: 'as yet unclassified' stamp: 'sec 10/18/2010 22:23'!
renderButtonsOn: html 
	html tableData;
		tableData: [html submitButton
				callback: [self save];
				 value: 'Save'.
			html submitButton
				callback: [self answer: false];
				 value: 'Cancel']! !

!EBookEditor methodsFor: 'as yet unclassified' stamp: 'sec 10/18/2010 22:19'!
renderContentOn: html 
	html div
		with: [html heading: 'Editing book'.
			html
				form: [html
						table: [ self mold canvas: html; tableRows.
							html tableRow: [self renderButtonsOn: html]]]].! !

!EBookEditor methodsFor: 'as yet unclassified' stamp: 'RS 10/18/2010 20:46'!
renderCopiesInputOn: html
	html
		tableData: [html text: 'Number of copies: '];
		tableData: [html textInput on: #copies of: self book].! !

!EBookEditor methodsFor: 'as yet unclassified' stamp: 'RS 10/18/2010 19:19'!
renderISBNInputOn: html
	html
		tableData: [html text: 'ISBN: '];
		tableData: [html textInput on: #isbn of: self book].! !

!EBookEditor methodsFor: 'as yet unclassified' stamp: 'RS 10/18/2010 19:19'!
renderTitleInputOn: html
	html
		tableData: [html text: 'Title: '];
		tableData: [html textInput on: #title of: self book].! !

!EBookEditor methodsFor: 'as yet unclassified' stamp: 'sec 10/18/2010 22:25'!
save
	self mold isValid ifFalse: [^self].
	self mold save.
	self answer.! !

WAComponent subclass: #ELibrary
	instanceVariableNames: 'bookComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Epic-Library'!

!ELibrary class methodsFor: 'as yet unclassified' stamp: 'RS 10/18/2010 21:21'!
canBeRoot
	^ true! !

!ELibrary methodsFor: 'accessing' stamp: 'sec 10/18/2010 22:32'!
bookComponent
	"Answer the value of bookComponent"

	^ bookComponent! !

!ELibrary methodsFor: 'accessing' stamp: 'sec 10/18/2010 22:32'!
bookComponent: anObject
	"Set the value of bookComponent"

	bookComponent := anObject! !

!ELibrary methodsFor: 'accessing' stamp: 'sec 10/18/2010 22:41'!
children
	^Array with: self bookComponent.! !

!ELibrary methodsFor: 'initialize-release' stamp: 'sec 10/18/2010 22:40'!
initialize
	super initialize.
	self bookComponent: EBookComponent new.! !

!ELibrary methodsFor: 'initialize-release' stamp: 'sec 10/18/2010 22:41'!
renderContentOn: html
	html render: self bookComponent.! !

WAComponent subclass: #EListComponent
	instanceVariableNames: 'items sortBlock filterBlock renderItemBlock columns'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Epic-Library'!

!EListComponent methodsFor: 'accessing' stamp: 'sec 10/19/2010 00:02'!
columns
	"Answer the value of columns"

	^ columns! !

!EListComponent methodsFor: 'accessing' stamp: 'sec 10/19/2010 00:02'!
columns: anObject
	"Set the value of columns"

	columns := anObject! !

!EListComponent methodsFor: 'accessing' stamp: 'RS 10/18/2010 18:29'!
filterBlock
	"Answer the value of filterBlock"

	^ filterBlock! !

!EListComponent methodsFor: 'accessing' stamp: 'RS 10/18/2010 18:29'!
filterBlock: anObject
	"Set the value of filterBlock"

	filterBlock := anObject! !

!EListComponent methodsFor: 'accessing' stamp: 'RS 10/18/2010 18:29'!
items
	"Answer the value of items"

	^ items! !

!EListComponent methodsFor: 'accessing' stamp: 'RS 10/18/2010 18:29'!
items: anObject
	"Set the value of items"

	items := anObject! !

!EListComponent methodsFor: 'rendering' stamp: 'sec 10/19/2010 00:02'!
renderContentOn: html 
	html
		table: [ html tableHead: [ self columns do: [:col | html tableData: col]].
			
			(self sortBlock
				value: (self filterBlock value: self items))
				do: [:item | html
						tableRow: [self renderItemBlock value: item value: html]]]! !

!EListComponent methodsFor: 'accessing' stamp: 'RS 10/18/2010 18:29'!
renderItemBlock
	"Answer the value of renderItemBlock"

	^ renderItemBlock! !

!EListComponent methodsFor: 'accessing' stamp: 'RS 10/18/2010 18:29'!
renderItemBlock: anObject
	"Set the value of renderItemBlock"

	renderItemBlock := anObject! !

!EListComponent methodsFor: 'accessing' stamp: 'RS 10/18/2010 18:29'!
sortBlock
	"Answer the value of sortBlock"

	^ sortBlock! !

!EListComponent methodsFor: 'accessing' stamp: 'RS 10/18/2010 18:29'!
sortBlock: anObject
	"Set the value of sortBlock"

	sortBlock := anObject! !

!EListComponent methodsFor: 'rendering' stamp: ''!
style ^ ''! !

WAComponent subclass: #EMenuComponent
	instanceVariableNames: 'entries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Epic-Library'!

!EMenuComponent methodsFor: 'as yet unclassified' stamp: 'RS 10/18/2010 19:38'!
addEntry: aString withAction: aBlock
	^ self entries add: aString -> aBlock! !

!EMenuComponent methodsFor: 'accessing' stamp: 'RS 10/18/2010 19:38'!
entries
	"Answer the value of entries"

	^ entries! !

!EMenuComponent methodsFor: 'accessing' stamp: 'RS 10/18/2010 19:38'!
entries: anObject
	"Set the value of entries"

	entries := anObject! !

!EMenuComponent methodsFor: 'as yet unclassified' stamp: 'RS 10/18/2010 19:39'!
initialize
	super initialize.	
	self entries: OrderedCollection new! !

!EMenuComponent methodsFor: 'as yet unclassified' stamp: 'RS 10/18/2010 19:37'!
renderContentOn: html 
	self entries
		do: [:entry | html anchor callback: entry value;
				 with: entry key]
		separatedBy: [html space]! !
